Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/io/io.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -35,5 +35,4 @@
 #include <stdio.h>
 #include <unistd.h>
-#include <fcntl.h>
 #include <assert.h>
 #include <str.h>
@@ -45,4 +44,5 @@
 #include <vfs/vfs.h>
 #include <vfs/vfs_sess.h>
+#include <vfs/inbox.h>
 #include <ipc/loc.h>
 #include <adt/list.h>
@@ -55,4 +55,5 @@
 static FILE stdin_null = {
 	.fd = -1,
+	.pos = 0, 
 	.error = true,
 	.eof = true,
@@ -69,4 +70,5 @@
 static FILE stdout_kio = {
 	.fd = -1,
+	.pos = 0, 
 	.error = false,
 	.eof = false,
@@ -83,4 +85,5 @@
 static FILE stderr_kio = {
 	.fd = -1,
+	.pos = 0, 
 	.error = false,
 	.eof = false,
@@ -101,8 +104,16 @@
 static LIST_INITIALIZE(files);
 
-void __stdio_init(int filc)
-{
-	if (filc > 0) {
-		stdin = fdopen(0, "r");
+void __stdio_init(void)
+{
+	/* The first three standard file descriptors are assigned for compatibility.
+	 * This will probably be removed later.
+	 */
+	 
+	int infd = inbox_get("stdin");
+	if (infd >= 0) {
+		int stdinfd = vfs_clone(infd, -1, false);
+		assert(stdinfd == 0);
+		vfs_open(stdinfd, MODE_READ);
+		stdin = fdopen(stdinfd, "r");
 	} else {
 		stdin = &stdin_null;
@@ -110,6 +121,12 @@
 	}
 	
-	if (filc > 1) {
-		stdout = fdopen(1, "w");
+	int outfd = inbox_get("stdout");
+	if (outfd >= 0) {
+		int stdoutfd = vfs_clone(outfd, -1, false);
+		assert(stdoutfd <= 1);
+		while (stdoutfd < 1)
+			stdoutfd = vfs_clone(outfd, -1, false);
+		vfs_open(stdoutfd, MODE_APPEND);
+		stdout = fdopen(stdoutfd, "a");
 	} else {
 		stdout = &stdout_kio;
@@ -117,6 +134,12 @@
 	}
 	
-	if (filc > 2) {
-		stderr = fdopen(2, "w");
+	int errfd = inbox_get("stderr");
+	if (errfd >= 0) {
+		int stderrfd = vfs_clone(errfd, -1, false);
+		assert(stderrfd <= 2);
+		while (stderrfd < 2)
+			stderrfd = vfs_clone(errfd, -1, false);
+		vfs_open(stderrfd, MODE_APPEND);
+		stderr = fdopen(stderrfd, "a");
 	} else {
 		stderr = &stderr_kio;
@@ -133,8 +156,8 @@
 }
 
-static bool parse_mode(const char *mode, int *flags)
+static bool parse_mode(const char *fmode, int *mode, bool *create, bool *truncate)
 {
 	/* Parse mode except first character. */
-	const char *mp = mode;
+	const char *mp = fmode;
 	if (*mp++ == 0) {
 		errno = EINVAL;
@@ -156,12 +179,18 @@
 		return false;
 	}
-	
-	/* Parse first character of mode and determine flags for open(). */
-	switch (mode[0]) {
+
+	*create = false;
+	*truncate = false;
+	
+	/* Parse first character of fmode and determine mode for vfs_open(). */
+	switch (fmode[0]) {
 	case 'r':
-		*flags = plus ? O_RDWR : O_RDONLY;
+		*mode = plus ? MODE_READ | MODE_WRITE : MODE_READ;
 		break;
 	case 'w':
-		*flags = (O_TRUNC | O_CREAT) | (plus ? O_RDWR : O_WRONLY);
+		*mode = plus ? MODE_READ | MODE_WRITE : MODE_WRITE;
+		*create = true;
+		if (!plus)
+			*truncate = true;
 		break;
 	case 'a':
@@ -171,5 +200,7 @@
 			return false;
 		}
-		*flags = (O_APPEND | O_CREAT) | (plus ? O_RDWR : O_WRONLY);
+
+		*mode = MODE_APPEND | (plus ? MODE_READ | MODE_WRITE : MODE_WRITE);
+		*create = true;
 		break;
 	default:
@@ -245,8 +276,11 @@
  *
  */
-FILE *fopen(const char *path, const char *mode)
-{
-	int flags;
-	if (!parse_mode(mode, &flags))
+FILE *fopen(const char *path, const char *fmode)
+{
+	int mode;
+	bool create;
+	bool truncate;
+
+	if (!parse_mode(fmode, &mode, &create, &truncate))
 		return NULL;
 	
@@ -257,12 +291,35 @@
 		return NULL;
 	}
-	
-	stream->fd = open(path, flags, 0666);
-	if (stream->fd < 0) {
-		/* errno was set by open() */
+
+	int flags = WALK_REGULAR;
+	if (create)
+		flags |= WALK_MAY_CREATE;
+	int file = vfs_lookup(path, flags);
+	if (file < 0) {
+		errno = file;
 		free(stream);
 		return NULL;
 	}
-	
+
+	int rc = vfs_open(file, mode);
+	if (rc != EOK) {
+		errno = rc;
+		vfs_put(file);
+		free(stream);
+		return NULL;
+	}
+	
+	if (truncate) {
+		rc = vfs_resize(file, 0);
+		if (rc != EOK) {
+			errno = rc;
+			vfs_put(file);
+			free(stream);
+			return NULL;
+		}
+	}
+
+	stream->fd = file;
+	stream->pos = 0;
 	stream->error = false;
 	stream->eof = false;
@@ -288,4 +345,5 @@
 	
 	stream->fd = fd;
+	stream->pos = 0;
 	stream->error = false;
 	stream->eof = false;
@@ -312,5 +370,5 @@
 	
 	if (stream->fd >= 0)
-		rc = close(stream->fd);
+		rc = vfs_put(stream->fd);
 	
 	list_remove(&stream->link);
@@ -373,27 +431,17 @@
 static size_t _fread(void *buf, size_t size, size_t nmemb, FILE *stream)
 {
-	size_t left, done;
-
 	if (size == 0 || nmemb == 0)
 		return 0;
 
-	left = size * nmemb;
-	done = 0;
-	
-	while ((left > 0) && (!stream->error) && (!stream->eof)) {
-		ssize_t rd = read(stream->fd, buf + done, left);
-		
-		if (rd < 0) {
-			/* errno was set by read() */
-			stream->error = true;
-		} else if (rd == 0) {
-			stream->eof = true;
-		} else {
-			left -= rd;
-			done += rd;
-		}
-	}
-	
-	return (done / size);
+	ssize_t rd = vfs_read(stream->fd, &stream->pos, buf, size * nmemb);
+	if (rd < 0) {
+		errno = rd;
+		stream->error = true;
+		rd = 0;
+	} else if (rd == 0) {
+		stream->eof = true;
+	}
+	
+	return (rd / size);
 }
 
@@ -410,48 +458,30 @@
 static size_t _fwrite(const void *buf, size_t size, size_t nmemb, FILE *stream)
 {
-	size_t left;
-	size_t done;
-	int rc;
-
 	if (size == 0 || nmemb == 0)
 		return 0;
 
-	left = size * nmemb;
-	done = 0;
-
-	while ((left > 0) && (!stream->error)) {
-		ssize_t wr;
-		size_t uwr;
-		
-		if (stream->kio) {
-			uwr = 0;
-			rc = kio_write(buf + done, left, &uwr);
-			if (rc != EOK)
-				errno = rc;
+	ssize_t wr;
+	if (stream->kio) {
+		size_t nwritten;
+		wr = kio_write(buf, size * nmemb, &nwritten);
+		if (wr != EOK) {
+			stream->error = true;
+			wr = 0;
 		} else {
-			wr = write(stream->fd, buf + done, left);
-			if (wr >= 0) {
-				uwr = (size_t)wr;
-				rc = EOK;
-			} else {
-				/* errno was set by write */
-				uwr = 0;
-				rc = errno;
-			}
+			wr = nwritten;
 		}
-		
-		if (rc != EOK) {
-			/* errno was set above */
+	} else {
+		wr = vfs_write(stream->fd, &stream->pos, buf, size * nmemb);
+		if (wr < 0) {
+			errno = wr;
 			stream->error = true;
-		} else {
-			left -= uwr;
-			done += uwr;
+			wr = 0;
 		}
 	}
 
-	if (done > 0)
+	if (wr > 0)
 		stream->need_sync = true;
 	
-	return (done / size);
+	return (wr / size);
 }
 
@@ -466,7 +496,7 @@
 	stream->buf_head = stream->buf_tail = stream->buf;
 
-	rc = read(stream->fd, stream->buf, stream->buf_size);
+	rc = vfs_read(stream->fd, &stream->pos, stream->buf, stream->buf_size);
 	if (rc < 0) {
-		/* errno was set by read() */
+		errno = rc;
 		stream->error = true;
 		return;
@@ -493,13 +523,6 @@
 
 	/* If buffer has prefetched read data, we need to seek back. */
-	if (bytes_used > 0 && stream->buf_state == _bs_read) {
-		off64_t rc;
-		rc = lseek(stream->fd, - (ssize_t) bytes_used, SEEK_CUR);
-		if (rc == (off64_t)-1) {
-			/* errno was set by lseek */
-			stream->error = 1;
-			return;
-		}
-	}
+	if (bytes_used > 0 && stream->buf_state == _bs_read)
+		stream->pos -= bytes_used;
 
 	/* If buffer has unwritten data, we need to write them out. */
@@ -773,21 +796,34 @@
 int fseek(FILE *stream, off64_t offset, int whence)
 {
-	off64_t rc;
+	int rc;
 
 	if (stream->error)
-		return EOF;
+		return -1;
 
 	_fflushbuf(stream);
 	if (stream->error) {
 		/* errno was set by _fflushbuf() */
-		return EOF;
+		return -1;
 	}
 
 	stream->ungetc_chars = 0;
 
-	rc = lseek(stream->fd, offset, whence);
-	if (rc == (off64_t) (-1)) {
-		/* errno has been set by lseek() */
-		return EOF;
+	struct stat st;
+	switch (whence) {
+	case SEEK_SET:
+		stream->pos = offset;
+		break;
+	case SEEK_CUR:
+		stream->pos += offset;
+		break;
+	case SEEK_END:
+		rc = vfs_stat(stream->fd, &st);
+		if (rc != EOK) {
+			errno = rc;
+			stream->error = true;
+			return -1;	
+		}
+		stream->pos = st.size + offset;
+		break;
 	}
 
@@ -798,6 +834,8 @@
 off64_t ftell(FILE *stream)
 {
-	off64_t pos;
-	
+	/* The native position is too large for the C99-ish interface. */
+	if (stream->pos - stream->ungetc_chars > INT64_MAX)
+		return EOF;
+
 	if (stream->error)
 		return EOF;
@@ -809,11 +847,5 @@
 	}
 
-	pos = lseek(stream->fd, 0, SEEK_CUR);
-	if (pos == (off64_t) -1) {
-		/* errno was set by lseek */
-		return (off64_t) -1;
-	}
-	
-	return pos - stream->ungetc_chars;
+	return stream->pos - stream->ungetc_chars;
 }
 
@@ -840,4 +872,6 @@
 	
 	if ((stream->fd >= 0) && (stream->need_sync)) {
+		int rc;
+
 		/**
 		 * Better than syncing always, but probably still not the
@@ -845,6 +879,7 @@
 		 */
 		stream->need_sync = false;
-		if (fsync(stream->fd) != 0) {
-			/* errno was set by fsync() */
+		rc = vfs_sync(stream->fd);
+		if (rc != EOK) {
+			errno = rc;
 			return EOF;
 		}
Index: uspace/lib/c/generic/io/logctl.c
===================================================================
--- uspace/lib/c/generic/io/logctl.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/io/logctl.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -39,4 +39,5 @@
 #include <ns.h>
 #include <str.h>
+#include <vfs/vfs.h>
 
 /** IPC session with the logger service. */
@@ -122,4 +123,30 @@
 }
 
+/** Set logger's VFS root.
+ *
+ * @return Error code or EOK on success.
+ */
+int logctl_set_root(void)
+{
+	async_exch_t *exchange = NULL;
+	int rc = start_logger_exchange(&exchange);
+	if (rc != EOK)
+		return rc;
+
+	aid_t reg_msg = async_send_0(exchange, LOGGER_CONTROL_SET_ROOT, NULL);
+	async_exch_t *vfs_exch = vfs_exchange_begin();
+	rc = vfs_pass_handle(vfs_exch, vfs_root(), exchange);
+	vfs_exchange_end(vfs_exch);
+	sysarg_t reg_msg_rc;
+	async_wait_for(reg_msg, &reg_msg_rc);
+
+	async_exchange_end(exchange);
+
+	if (rc != EOK)
+		return rc;
+
+	return (int) reg_msg_rc;
+}
+
 /** @}
  */
Index: uspace/lib/c/generic/libc.c
===================================================================
--- uspace/lib/c/generic/libc.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/libc.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -48,4 +48,6 @@
 #include <task.h>
 #include <loader/pcb.h>
+#include <vfs/vfs.h>
+#include <vfs/inbox.h>
 #include "private/libc.h"
 #include "private/async.h"
@@ -107,10 +109,12 @@
 		argc = 0;
 		argv = NULL;
-		__stdio_init(0);
+		__stdio_init();
 	} else {
 		argc = __pcb->argc;
 		argv = __pcb->argv;
-		__stdio_init(__pcb->filc);
-		(void) chdir(__pcb->cwd);
+		__inbox_init(__pcb->inbox, __pcb->inbox_entries);
+		__stdio_init();
+		vfs_root_set(inbox_get("root"));
+		(void) vfs_cwd_set(__pcb->cwd);
 	}
 	
Index: uspace/lib/c/generic/loader.c
===================================================================
--- uspace/lib/c/generic/loader.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/loader.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -124,5 +124,5 @@
 		return ENOMEM;
 	
-	if (getcwd(cwd, MAX_PATH_LEN + 1) == NULL)
+	if (vfs_cwd_get(cwd, MAX_PATH_LEN + 1) != EOK)
 		str_cpy(cwd, MAX_PATH_LEN + 1, "/");
 	
@@ -147,41 +147,65 @@
 }
 
-/** Set pathname of the program to load.
- *
- * Sets the name of the program file to load. The name can be relative
- * to the current working directory (it will be absolutized before
- * sending to the loader).
+/** Set the program to load.
  *
  * @param ldr  Loader connection structure.
- * @param path Pathname of the program file.
- *
- * @return Zero on success or negative error code.
- *
- */
-int loader_set_pathname(loader_t *ldr, const char *path)
-{
-	size_t pa_len;
-	char *pa = vfs_absolutize(path, &pa_len);
-	if (!pa)
-		return ENOMEM;
-	
-	/* Send program pathname */
-	async_exch_t *exch = async_exchange_begin(ldr->sess);
-	
+ * @param name Name to set for the spawned program.
+ * @param file Program file.
+ *
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_set_program(loader_t *ldr, const char *name, int file)
+{
+	async_exch_t *exch = async_exchange_begin(ldr->sess);
+
 	ipc_call_t answer;
-	aid_t req = async_send_0(exch, LOADER_SET_PATHNAME, &answer);
-	sysarg_t rc = async_data_write_start(exch, (void *) pa, pa_len);
-	
-	async_exchange_end(exch);
-	free(pa);
-	
+	aid_t req = async_send_0(exch, LOADER_SET_PROGRAM, &answer);
+
+	sysarg_t rc = async_data_write_start(exch, name, str_size(name) + 1);
+	if (rc == EOK) {
+		async_exch_t *vfs_exch = vfs_exchange_begin();
+		rc = vfs_pass_handle(vfs_exch, file, exch);
+		vfs_exchange_end(vfs_exch);
+	}
+
+	async_exchange_end(exch);
+
 	if (rc != EOK) {
 		async_forget(req);
 		return (int) rc;
 	}
-	
+
 	async_wait_for(req, &rc);
 	return (int) rc;
 }
+
+/** Set the program to load by path.
+ *
+ * @param ldr  Loader connection structure.
+ * @param path Program path.
+ *
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_set_program_path(loader_t *ldr, const char *path)
+{
+	const char *name = str_rchr(path, '/');
+	if (name == NULL) {
+		name = path;
+	} else {
+		name++;
+	}
+	
+	int fd = vfs_lookup(path, 0);
+	if (fd < 0) {
+		return fd;
+	}
+	
+	int rc = loader_set_program(ldr, name, fd);
+	vfs_put(fd);
+	return rc;
+}
+
 
 /** Set command-line arguments for the program.
@@ -244,46 +268,34 @@
 }
 
-/** Set preset files for the program.
- *
- * Sets the vector of preset files to be passed to the loaded
- * program. By convention, the first three files represent stdin,
- * stdout and stderr respectively.
- *
- * @param ldr   Loader connection structure.
- * @param files NULL-terminated array of pointers to files.
- *
- * @return Zero on success or negative error code.
- *
- */
-int loader_set_files(loader_t *ldr, int * const files[])
-{
-	/* Send serialized files to the loader */
+/** Add a file to the task's inbox.
+ *
+ * @param ldr        Loader connection structure.
+ * @param name       Identification of the file.
+ * @param file       The file's descriptor.
+ *
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_add_inbox(loader_t *ldr, const char *name, int file)
+{
 	async_exch_t *exch = async_exchange_begin(ldr->sess);
 	async_exch_t *vfs_exch = vfs_exchange_begin();
 	
-	int i;
-	for (i = 0; files[i]; i++);
-
-	ipc_call_t answer;
-	aid_t req = async_send_1(exch, LOADER_SET_FILES, i, &answer);
-
-	sysarg_t rc = EOK;
-	
-	for (i = 0; files[i]; i++) {
-		rc = async_state_change_start(exch, VFS_PASS_HANDLE, *files[i],
-		    0, vfs_exch); 
-		if (rc != EOK)
-			break;
-	}
-	
-	vfs_exchange_end(vfs_exch);
-	async_exchange_end(exch);
-
-	if (rc != EOK) {
-		async_forget(req);
-		return (int) rc;
-	}
-	
-	async_wait_for(req, &rc);
+	aid_t req = async_send_0(exch, LOADER_ADD_INBOX, NULL);
+	
+	sysarg_t rc = async_data_write_start(exch, name, str_size(name) + 1);
+	if (rc == EOK) {
+		rc = vfs_pass_handle(vfs_exch, file, exch);
+	}
+	
+	async_exchange_end(vfs_exch);
+	async_exchange_end(exch);
+	
+	if (rc == EOK) {
+		async_wait_for(req, &rc);
+	} else {
+		async_forget(req);
+	}
+	
 	return (int) rc;
 }
Index: uspace/lib/c/generic/private/io.h
===================================================================
--- uspace/lib/c/generic/private/io.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/private/io.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -36,6 +36,10 @@
 #define LIBC_PRIVATE_IO_H_
 
-extern void __stdio_init(int);
+#include <loader/pcb.h>
+
+extern void __stdio_init(void);
 extern void __stdio_done(void);
+
+extern void __inbox_init(struct pcb_inbox_entry *entries, int count);
 
 #endif
Index: uspace/lib/c/generic/private/stdio.h
===================================================================
--- uspace/lib/c/generic/private/stdio.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/private/stdio.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -49,4 +49,7 @@
 	/** Underlying file descriptor. */
 	int fd;
+
+	/** File position. */
+	aoff64_t pos;
 	
 	/** Error indicator. */
Index: uspace/lib/c/generic/rtld/module.c
===================================================================
--- uspace/lib/c/generic/rtld/module.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/rtld/module.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -38,5 +38,4 @@
 #include <elf/elf_load.h>
 #include <errno.h>
-#include <fcntl.h>
 #include <loader/pcb.h>
 #include <stdio.h>
@@ -196,5 +195,5 @@
 	DPRINTF("load '%s' at 0x%x\n", name_buf, m->bias);
 
-	rc = elf_load_file(name_buf, m->bias, ELDF_RW, &info);
+	rc = elf_load_file_name(name_buf, m->bias, ELDF_RW, &info);
 	if (rc != EE_OK) {
 		printf("Failed to load '%s'\n", name_buf);
Index: uspace/lib/c/generic/task.c
===================================================================
--- uspace/lib/c/generic/task.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/task.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -48,4 +48,5 @@
 #include "private/ns.h"
 #include <vfs/vfs.h>
+#include <unistd.h>
 
 task_id_t task_get_id(void)
@@ -107,27 +108,23 @@
 {
 	/* Send default files */
-	int *files[4];
-	int fd_stdin;
-	int fd_stdout;
-	int fd_stderr;
-	
-	if ((stdin != NULL) && (vfs_fhandle(stdin, &fd_stdin) == EOK))
-		files[0] = &fd_stdin;
-	else
-		files[0] = NULL;
-	
-	if ((stdout != NULL) && (vfs_fhandle(stdout, &fd_stdout) == EOK))
-		files[1] = &fd_stdout;
-	else
-		files[1] = NULL;
-	
-	if ((stderr != NULL) && (vfs_fhandle(stderr, &fd_stderr) == EOK))
-		files[2] = &fd_stderr;
-	else
-		files[2] = NULL;
-	
-	files[3] = NULL;
-	
-	return task_spawnvf(id, wait, path, args, files);
+	
+	int fd_stdin = -1;
+	int fd_stdout = -1;
+	int fd_stderr = -1;
+	
+	if (stdin != NULL) {
+		(void) vfs_fhandle(stdin, &fd_stdin);
+	}
+	
+	if (stdout != NULL) {
+		(void) vfs_fhandle(stdout, &fd_stdout);
+	}
+
+	if (stderr != NULL) {
+		(void) vfs_fhandle(stderr, &fd_stderr);
+	}
+	
+	return task_spawnvf(id, wait, path, args, fd_stdin, fd_stdout,
+	    fd_stderr);
 }
 
@@ -138,10 +135,11 @@
  * Files are passed as null-terminated array of pointers to fdi_node_t.
  *
- * @param id    If not NULL, the ID of the task is stored here on success.
- * @param wait  If not NULL, setup waiting for task's return value and store
- *              the information necessary for waiting here on success.
- * @param path  Pathname of the binary to execute.
- * @param argv  Command-line arguments.
- * @param files Standard files to use.
+ * @param id      If not NULL, the ID of the task is stored here on success.
+ * @param wait    If not NULL, setup waiting for task's return value and store
+ * @param path    Pathname of the binary to execute.
+ * @param argv    Command-line arguments.
+ * @param std_in  File to use as stdin.
+ * @param std_out File to use as stdout.
+ * @param std_err File to use as stderr.
  *
  * @return Zero on success or negative error code.
@@ -149,5 +147,5 @@
  */
 int task_spawnvf(task_id_t *id, task_wait_t *wait, const char *path,
-    const char *const args[], int *const files[])
+    const char *const args[], int fd_stdin, int fd_stdout, int fd_stderr)
 {
 	/* Connect to a program loader. */
@@ -169,6 +167,6 @@
 		goto error;
 	
-	/* Send program pathname. */
-	rc = loader_set_pathname(ldr, path);
+	/* Send program binary. */
+	rc = loader_set_program_path(ldr, path);
 	if (rc != EOK)
 		goto error;
@@ -180,7 +178,29 @@
 	
 	/* Send files */
-	rc = loader_set_files(ldr, files);
-	if (rc != EOK)
-		goto error;
+	int root = vfs_root();
+	if (root >= 0) {
+		rc = loader_add_inbox(ldr, "root", root);
+		vfs_put(root);
+		if (rc != EOK)
+			goto error;
+	}
+	
+	if (fd_stdin >= 0) {
+		rc = loader_add_inbox(ldr, "stdin", fd_stdin);
+		if (rc != EOK)
+			goto error;
+	}
+	
+	if (fd_stdout >= 0) {
+		rc = loader_add_inbox(ldr, "stdout", fd_stdout);
+		if (rc != EOK)
+			goto error;
+	}
+	
+	if (fd_stderr >= 0) {
+		rc = loader_add_inbox(ldr, "stderr", fd_stderr);
+		if (rc != EOK)
+			goto error;
+	}		
 	
 	/* Load the program. */
Index: uspace/lib/c/generic/vfs/inbox.c
===================================================================
--- uspace/lib/c/generic/vfs/inbox.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
+++ uspace/lib/c/generic/vfs/inbox.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -0,0 +1,175 @@
+/*
+ * Copyright (c) 2013 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc 
+ * @{
+ */ 
+
+/**
+ * @file
+ * @brief
+ */
+
+#include <vfs/inbox.h>
+#include <vfs/vfs.h>
+
+#include <adt/list.h>
+#include <str.h>
+#include <stdlib.h>
+#include <loader/pcb.h>
+#include "../private/io.h"
+#include <errno.h>
+
+/*
+ * This is an attempt at generalization of the "standard files" concept to
+ * arbitrary names.  When loading a task, the parent can put arbitrary files to
+ * an "inbox" through IPC calls, every file in an inbox has a name assigned
+ * (e.g. "stdin", "stdout", "stderr", "data", "logfile", etc.). The client then
+ * retrieves those files from inbox by name. "stdin", "stdout" and "stderr" are
+ * handled automatically by libc to initialize standard <stdio.h> streams and
+ * legacy file descriptors 0, 1, 2. Other names are subject to conventions and
+ * application-specific rules.
+ */
+
+typedef struct {
+	link_t link;
+	char *name;
+	int file;
+} inbox_entry;
+
+static LIST_INITIALIZE(inb_list);
+
+/* Inserts a named file into the inbox.
+ *
+ * If a file with the same name is already present, it overwrites it and returns
+ * the original value. Otherwise, it returns -1.  If the argument 'file' is -1,
+ * nothing is inserted and the file with specified name is removed and returned
+ * if present.
+ *
+ * @param name Name of the inbox entry.
+ * @param file File to insert or -1.
+ * @return Original value of the entry or -1 if not originally present.
+ */
+int inbox_set(const char *name, int file)
+{
+	inbox_entry *next = NULL;
+	
+	list_foreach(inb_list, link, inbox_entry, e) {
+		int cmp = str_cmp(e->name, name);
+		switch (cmp) {
+		case -1:
+			continue;
+		case 0:;
+			int result = e->file;
+			if (file == -1) {
+				free(e->name);
+				/* Safe because we exit immediately. */
+				list_remove(&e->link);
+			} else {
+				e->file = file;
+			}
+			return result;
+		case 1:
+			next = e;
+			goto out;
+		}
+	}
+
+out:
+	if (file == -1)
+		return -1;
+
+	inbox_entry *entry = calloc(sizeof(inbox_entry), 1);
+	entry->name = str_dup(name);
+	entry->file = file;
+
+	if (next == NULL) {
+		list_append((link_t *)entry, &inb_list);
+	} else {
+		list_insert_before((link_t *)entry, (link_t *)next);
+	}
+	return -1;
+}
+
+/* Retrieve a file with this name.
+ *
+ * @param name Name of the entry.
+ * @return Requested file or ENOENT if not set.
+ */
+int inbox_get(const char *name)
+{
+	list_foreach(inb_list, link, inbox_entry, e) {
+		int cmp = str_cmp(e->name, name);
+		switch (cmp) {
+		case 0:
+			return e->file;
+		case 1:
+			return ENOENT;
+		} 
+	}
+
+	return ENOENT;
+}
+
+/* Writes names of entries that are currently set into an array provided by the
+ * user.
+ *
+ * @param names Array in which names are stored.
+ * @param capacity Capacity of the array.
+ * @return Number of entries written. If capacity == 0, return the total number
+ *         of entries.
+ */
+int inbox_list(const char **names, int capacity)
+{
+	if (capacity == 0)
+		return list_count(&inb_list);
+
+	int used = 0;
+
+	list_foreach(inb_list, link, inbox_entry, e) {
+		if (used == capacity)
+			return used;
+		names[used] = e->name;
+		used++;
+	}
+
+	return used;
+}
+
+void __inbox_init(struct pcb_inbox_entry *entries, int count)
+{
+	for (int i = 0; i < count; i++) {
+		int original = inbox_set(entries[i].name, entries[i].file);
+		if (original >= 0)
+			vfs_put(original);
+	}
+}
+
+/**
+ * @}
+ */
Index: uspace/lib/c/generic/vfs/mtab.c
===================================================================
--- uspace/lib/c/generic/vfs/mtab.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
+++ uspace/lib/c/generic/vfs/mtab.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -0,0 +1,136 @@
+/*
+ * Copyright (c) 2008 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <vfs/vfs.h>
+#include <vfs/vfs_mtab.h>
+#include <macros.h>
+#include <stdlib.h>
+#include <dirent.h>
+#include <sys/types.h>
+#include <errno.h>
+#include <assert.h>
+
+static void process_mp(const char *path, struct stat *stat, list_t *mtab_list)
+{
+	mtab_ent_t *ent;
+
+	ent = (mtab_ent_t *) malloc(sizeof(mtab_ent_t));
+	if (!ent)
+		return;
+
+	link_initialize(&ent->link);
+	str_cpy(ent->mp, sizeof(ent->mp), path);
+	ent->service_id = stat->service_id;
+
+	struct statfs stfs;
+	if (vfs_statfs_path(path, &stfs) == EOK)
+		str_cpy(ent->fs_name, sizeof(ent->fs_name), stfs.fs_name);
+	else
+		str_cpy(ent->fs_name, sizeof(ent->fs_name), "?");
+	
+	list_append(&ent->link, mtab_list);
+}
+
+static int vfs_get_mtab_visit(const char *path, list_t *mtab_list,
+    fs_handle_t fs_handle, service_id_t service_id)
+{
+	DIR *dir;
+	struct dirent *dirent;
+
+	dir = opendir(path);
+	if (!dir)
+		return ENOENT;
+
+	while ((dirent = readdir(dir)) != NULL) {
+		char *child;
+		struct stat st;
+		int rc;
+
+		rc = asprintf(&child, "%s/%s", path, dirent->d_name);
+		if (rc < 0) {
+			closedir(dir);
+			return rc;
+		}
+
+		char *pa = vfs_absolutize(child, NULL);
+		if (!pa) {
+			free(child);
+			closedir(dir);
+			return ENOMEM;
+		}
+
+		free(child);
+		child = pa;
+
+		rc = vfs_stat_path(child, &st);
+		if (rc != 0) {
+			free(child);
+			closedir(dir);
+			return rc;
+		}
+
+		if (st.fs_handle != fs_handle || st.service_id != service_id) {
+			/*
+			 * We have discovered a mountpoint.
+			 */
+			process_mp(child, &st, mtab_list);
+		}
+
+		if (st.is_directory) {
+			(void) vfs_get_mtab_visit(child, mtab_list,
+			    st.fs_handle, st.service_id);
+		}
+
+		free(child);
+	}
+
+	closedir(dir);
+	return EOK;
+}
+
+int vfs_get_mtab_list(list_t *mtab_list)
+{
+	struct stat st;
+
+	int rc = vfs_stat_path("/", &st);
+	if (rc != 0)
+		return rc;
+
+	process_mp("/", &st, mtab_list);
+
+	return vfs_get_mtab_visit("/", mtab_list, st.fs_handle, st.service_id);
+}
+
+/** @}
+ */
